//-------------------
// Benchmark Othello
// version WIN32 et POCKETPC
// Sylvain Huet
// Premiere version : 24/08/2002
// Derniere mise a jour : 26/08/2002

#include "types.h"
#include "eval.h"

long compteur;

int valcase[100]=
{
	 0	,0	,0	,0	,0	,0	,0	,0	,0	,0
	,0	,20	,-5	,5	,5	,5	,5	,-5	,20	,0	
	,0	,-5	,-10,0	,0	,0	,0	,-10,-5	,0	
	,0	,5	,0	,0	,0	,0	,0	,0	,5	,0	
	,0	,5	,0	,0	,0	,0	,0	,0	,5	,0	
	,0	,5	,0	,0	,0	,0	,0	,0	,5	,0	
	,0	,5	,0	,0	,0	,0	,0	,0	,5	,0	
	,0	,-5	,-10,0	,0	,0	,0	,-10,-5	,0	
	,0	,20	,-5	,5	,5	,5	,5	,-5	,20	,0	
	,0	,0	,0	,0	,0	,0	,0	,0	,0	,0	
};
// retourne la diffrence du nombre de pions
int diffpions(char *tab,int coul)
{
	int i,j,val;

	val=0;
	for (j=10;j<90;j+=10)
		for (i=j+1;i<j+9;i++)
			val+=tab[i];

	if (coul<0) val=-val;
	return val;
}

// retourne le nombre de pions
int nbpions(char *tab)
{
	int i,j,val;

	val=0;
	for (j=10;j<90;j+=10)
		for (i=j+1;i<j+9;i++)
			val+=(tab[i]&1);

	return val;
}

// retourne la diffrence du nombre de pions frontires
int diffpionsbord(char *tab,int coul)
{
	int i,j,val;

	val=0;
	for (j=10;j<90;j+=10)
		for (i=j+1;i<j+9;i++)
			if (tab[i])
			{
				if (!(tab[i+depla[1]]&tab[i+depla[3]]&tab[i+depla[4]]&tab[i+depla[6]]&1))
					val+=tab[i];
			}
	if (coul<0) val=-val;
	return val;
}

// retourne la diffrence des scores des cases
int diffscore(char *tab,int coul)
{
	int i,j,val;

	val=0;
	for (j=10;j<90;j+=10)
		for (i=j+1;i<j+9;i++)
			if (tab[i]>0) val+=valcase[i];
			else if (tab[i]<0) val-=valcase[i];
	if (coul<0) val=-val;
	return val;
}

int eval(char *tab,int coul)
{
	int val;
	int nb;
	compteur++;

	nb=nbpions(tab);
	if (nb<55) val=-diffpionsbord(tab,coul);
	else val=diffpions(tab,coul);
	if (nb<55) val+=diffscore(tab,coul);
	return val;
}

// retourne le nombre de pions blancs
int pionsblancs(char *tab)
{
	int i,j,val;

	val=0;
	for (j=10;j<90;j+=10)
		for (i=j+1;i<j+9;i++)
			if (tab[i]>0) val++;

	return val;
}

// retourne le nombre de pions noirs
int pionsnoirs(char *tab)
{
	int i,j,val;

	val=0;
	for (j=10;j<90;j+=10)
		for (i=j+1;i<j+9;i++)
			if (tab[i]<0) val++;

	return val;
}


